Subject: Re: [PATCH 08/40] mm: kmem_cache_objsize

From: Peter Zijlstra <[email-masked]>
Date: Fri, 04 May 2007 19:59:05 +0200

On Fri, 2007-05-04 at 09:36 -0700, Christoph Lameter wrote:
> On Fri, 4 May 2007, Peter Zijlstra wrote:
> 
> > Expost buffer_size in order to allow fair estimates on the actual space 
> > used/needed.
> 
> If its just an estimate that you are after then I think ksize is 
> sufficient.
> 
> The buffer size does not include the other per slab overhead that SLAB 
> needs nor the alignment overhead or the padding. For SLUB you'd be more 
> lucky but there it does not include the per slab padding that exist.
> 
> Need to check how this is going to be used. It is difficult to estimate 
> slab use because this depends on the availability of object slots in 
> partial slabs.
> 
> I could add a function that tells you how many object you could allocate 
> from a slab without the page allocator becoming involved? It would count 
> the object slots available on the partial slabs.

I need to know how many pages to reserve to allocate a given number of
items from a given slab; assuming the partial slabs are empty. That is,
I need a worst case upper bound.